;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Kbc} (ネbN}) by tan-cos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!Y_SP		= !AA
!X_SP		= !B6
!Y_LOW		= !D8
!X_LOW		= !E4
!HP_MARIO	= $0F48
!Y_HIGH		= !14D4
!X_HIGH		= !14E0
!POSE		= !1504
!STATE		= !151C
!HP_BOSS	= !1528
!FLAG		= !1534
!DAMAGE		= !1558
!TIMER		= !1564
!TOUCH		= !1588		;HFLR
!SP_RAM		= !1594
!FLAG2		= !15B8
!OLD_HP		= !1626

!SPRITE_NAM		= $01		;΃XvCgԍ

!Y_SPEED		= $A0		;Wv͂

!FIRE_DAMAGE	= $01		;t@CAɂ_[W

!GUTS_POWER	= $04		;Kbc}̍U

!EARTH_TIME	= $40		;nk^C}[


X_SPEED:		db $10,$F0,$00,$00	;ړx


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	print "INIT ",pc
	LDA #$03
	STA $19
	STZ $0DC2
	LDA #$1C
	STA !HP_MARIO
	STA !HP_BOSS,x
	LDA #$03
	STA !POSE,x
	LDA #$00
	STA !HP_BOSS,x
	RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	print "MAIN ",pc
	PHB                     ; \
	PHK                     ;  | main sprite function, just calls local subroutine
	PLB                     ;  |
	JSR START_HB_CODE       ;  |
	PLB                     ;  |
	RTL                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN:
	RTS
START_HB_CODE:
	JSR SUB_GFX
	LDA $14C8,x
	CMP #$08
	BNE RETURN
	LDA $9D
	BNE RETURN
	%SubOffScreen()
	
	LDA !HP_MARIO
	BNE SKIP_TKTK
	LDA !FLAG2,x
	BNE DELETE_HP
	JSR SET_MARIO_BLK
	JSL $00F606
	BRA SKIP_TKTK
DELETE_HP:
	JSR DELETE_BLK
SKIP_TKTK:

	LDA $1540,x
	BEQ NOT_BOMBER
	CMP #$01
	BEQ DELETE
	LDA $167A,x
	AND #$7F
	STA $167A,x
	PHB 
	LDA #$02
	PHA
	PLB
	JSL $028086
	PLB
	RTS
DELETE:
	LDA #$00
	STA $00
	STA $01
	STA $02
	STA $03
	LDA #$4A
	CLC
	%SpawnSprite()
	STZ $14C8,x
	RTS
NOT_BOMBER:
	LDA !STATE,x
	CMP #$03
	BCC SKIP_TIWN
	LDA !HP_BOSS,x
	BNE SKIP_TIWN
	LDA $1540,x
	BNE SKIP_TIWN
	
	LDA #$40
	STA $1540,x
	LDA #$16
	STA $1DFC
	LDA #$60
	STA $1497
	LDA #$01
	STA !FLAG2,x
	JSR DELETE_BLK
SKIP_TIWN:
	LDA !STATE,x
	CMP #$03
	BCC SKIP_MARIO_BLK
	LDA !OLD_HP,x
	CMP !HP_MARIO
	BEQ SKIP_MARIO_BLK
	LDA !FLAG2,x
	BNE SKIP_MARIO_BLK
	LDA !HP_MARIO
	STA !OLD_HP,x
	JSR SET_MARIO_BLK
SKIP_MARIO_BLK:
	LDA !X_LOW,x
	CMP $94
	BCS LOOK_MARIO
	LDA #$00
	STA $157C,x
	BRA LOOK_MARIO_END
LOOK_MARIO:
	LDA #$01
	STA $157C,x
LOOK_MARIO_END:
START:
	LDA !TIMER,x
	BEQ NO_TIME
	JMP TURN
NO_TIME:
	LDA !STATE,x
	CMP #$03
	BCS WAIT_HP
	LDA #$0D
	STA $71
	LDA !TOUCH,x
	AND #$04
	BNE ON_GND
	JMP TURN
WAIT_HP:
	JMP LAST_WAIT_HP
ON_GND:
	LDA !STATE,x
	CMP #$01
	BCS HP_COUNT
	LDA #$01
	STA !STATE,x
	LDA #$00
	STA !POSE,x
	LDA #$16
	STA $1DFC
	LDA #$00
	STA !X_SP,x
	LDA #$30
	STA $1887
	LDA #$20
	STA !TIMER,x
	JMP TURN
HP_COUNT:
	LDA !STATE,x
	CMP #$02
	BCS HP_END
	JSR SET_HP_BLK
	LDA #$02
	STA !STATE,x
	LDA #$04
	STA !POSE,x
	LDA #$08
	STA !TIMER,x
	JMP TURN
HP_END:
	LDA !STATE,x
	CMP #$03
	BCS LAST_WAIT_HP
	LDA !HP_BOSS,x
	CMP #$1C
	BCS END_COUNT_HP
	LDA !HP_BOSS,x
	INC A
	STA !HP_BOSS,x
	JSR SET_BOSS_BLK
	LDA #$01
	STA $1DFC
	LDA #$02
	STA !TIMER,x
	JMP TURN
END_COUNT_HP:
	LDA #$03
	STA !STATE,x
	LDA #$40
	STA !TIMER,x
	JMP TURN
LAST_WAIT_HP:
	LDA !FLAG2,x
	BNE WAIT_START
	JSR SET_MARIO_BLK
WAIT_START:
	LDA !STATE,x
	CMP #$04
	BCS JUMP_START
	LDA #$00
	STA $71			;}I~
	LDA #$02
	STA !POSE,x
	JSL $01ACF9		;
	AND #$01
	BEQ NO_ROCK_FLAG
	LDA #$01
	STA !FLAG,x
	BRA SKIP_SET_X
NO_ROCK_FLAG:
	LDA !TOUCH,x
	AND #$01		;RIGHTɂĂ邩
	BEQ JUMP1		;Ȃ00
	LDA #$00
	BRA JUMP4
JUMP1:
	LDA !TOUCH,x
	AND #$02		;LEFTɂĂ邩
	BEQ JUMP2		;Ȃ01
	LDA #$01
	BRA JUMP4
JUMP2:
	LDA $148E
	AND #$01
JUMP4:
	PHY
	TAY
	LDA X_SPEED,y
	STA !X_SP,x
	PLY
SKIP_SET_X:
	LDA #$C0
	STA !Y_SP,x
	LDA #$03
	STA !POSE,x
	LDA #$04
	STA !STATE,x
	JMP TURN
JUMP_START:
	LDA !STATE,x
	CMP #$05
	BCS JUMP_UP
	LDA #$05
	STA !STATE,x
	JMP TURN
JUMP_UP:
	LDA !STATE,x
	CMP #$06
	BCS JUMP_DOWN
	LDA !TOUCH,x
	AND #$03
	BEQ NO_STOP2
	LDA #$00
	STA !X_SP,x
NO_STOP2:

	LDA !TOUCH,x
	AND #$04
	BEQ IN_AIR
	LDA #$00
	STA !POSE,x
	LDA #$16
	STA $1DFC
	LDA #$00
	STA !X_SP,x
	LDA #!EARTH_TIME
	STA $1887
	LDA $77
	AND #$04
	BEQ MARIO_IN_AIR
	LDA #!EARTH_TIME
	STA $18BD
MARIO_IN_AIR:
	LDA !FLAG,x
	BEQ NO_FLAG
	LDA #$10
	STA !STATE,x
	JMP TURN
NO_FLAG:
	LDA #$06
	STA !STATE,x
IN_AIR:
	JMP TURN
JUMP_DOWN:
	LDA !STATE,x
	CMP #$07
	BCS WAIT01
	LDA #$07
	STA !STATE,x
	LDA #$00
	STA !POSE,x
	LDA #$10
	STA !TIMER,x
	JMP TURN
WAIT01:
	LDA !STATE,x
	CMP #$08
	BCS WAIT02
	LDA #$08
	STA !STATE,x
	LDA #$01
	STA !POSE,x
	LDA #$10
	STA !TIMER,x
	JMP TURN
WAIT02:
	LDA !STATE,x
	CMP #$09
	BCS WAIT03
	LDA #$09
	STA !STATE,x
	LDA #$00
	STA !POSE,x
	LDA #$10
	STA !TIMER,x
	JMP TURN
WAIT03:
	LDA !STATE,x
	CMP #$0A
	BCS WAIT04
	LDA #$0A
	STA !STATE,x
	LDA #$01
	STA !POSE,x
	LDA #$10
	STA !TIMER,x
	JMP TURN
WAIT04:
	LDA !STATE,x
	CMP #$0B
	BCS ROCK_FALL
	LDA #$03
	STA !STATE,x
	LDA #$00
	STA !POSE,x
	LDA #$10
	STA !TIMER,x
	JMP TURN
ROCK_FALL:
	LDA !STATE,x
	CMP #$11
	BCS ROCK_CATCH
	LDA #$04
	STA !POSE,x
	
	LDA #$80
	STA $01
	LDA #$00
	STA $00
	STA $02
	STA $03
	LDA #!SPRITE_NAM
	SEC
	%SpawnSprite()
	
	TYA
	STA !SP_RAM,x
	LDA #$11
	STA !STATE,x
	JMP TURN
ROCK_CATCH:
	LDA !STATE,x
	CMP #$12
	BCS ROCK_THROW_WAIT
	LDA !SP_RAM,x
	TAY
	LDA !Y_HIGH,x
	CMP !Y_HIGH,y
	BNE NO_CATCH
	LDA !Y_LOW,x
	SEC
	SBC #$20
	CMP !Y_LOW,y
	BCS NO_CATCH
	LDA #$00
	STA !Y_SP,y
	LDA #$10
	STA $1DFC
	LDA #$12
	STA !STATE,x
NO_CATCH:
	JMP TURN
ROCK_THROW_WAIT:
	LDA !STATE,x
	CMP #$13
	BCS ROCK_THROW
	LDA #$13
	STA !STATE,x
	LDA #$20
	STA !TIMER,x
ROCK_THROW:
	LDA !STATE,x
	CMP #$14
	BCS LAST_WAIT_ROCK

	LDA !14E0,x
	XBA
	LDA !E4,x
	REP #$20
	SEC
	SBC $94
	STA $00
	SEP #$20

	LDA !14D4,x
	XBA
	LDA !D8,x
	REP #$20
	SEC
	SBC #$0008
	SBC $96
	STA $02
	SEP #$20

	LDA #80
	%Aiming()

	LDA !SP_RAM,x
	TAY
	LDA $00
	STA !X_SP,y
	LDA $02
	STA !Y_SP,y	

	LDA $157C,x
	STA $157C,y
	LDA #$03
	STA $1DF9
	LDA #$05
	STA !POSE,x
	LDA #$14
	STA !STATE,x
	LDA #$10
	STA !TIMER,x
	JMP TURN
LAST_WAIT_ROCK:
	LDA #$00
	STA !FLAG,x
	STA !POSE,x
	LDA #$03
	STA !STATE,x
	LDA #$20
	STA !TIMER,x
	JMP TURN
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  3rd routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TURN:
	JSL $01802A
	JSR CHECK_FIREBALL
	BEQ SKIP_FIRE
	JMP MARIO_FIRE_WIN
SKIP_FIRE:
	JSL $01A7DC
	BCC NOT_CONTACT
;	LDA $7D
;	CMP #$10
;	BMI BOSS_WIN
	BRA BOSS_WIN
MARIO_WIN:
	LDA !DAMAGE,x
	BNE NOT_CONTACT
	JSL $01AA33
	LDA #$28
	STA $1DFC
	LDA !HP_BOSS,x
	DEC A
	DEC A
	STA !HP_BOSS,x
	LDA #$40
	STA !DAMAGE,x
	JSR SET_BOSS_BLK
	RTS
MARIO_FIRE_WIN:
	LDA !DAMAGE,x
	BNE NOT_CONTACT
	LDA !HP_BOSS,x
	CMP #!FIRE_DAMAGE
	BCC TIWN
	BEQ TIWN
	LDA #$28
	STA $1DFC
	LDA !HP_BOSS,x
	SEC
	SBC #!FIRE_DAMAGE
	STA !HP_BOSS,x
	LDA #$40
	STA !DAMAGE,x
	JSR SET_BOSS_BLK
	RTS
TIWN:
	LDA #$00
	STA !HP_BOSS,x
	RTS
BOSS_WIN:
	LDA $1497
	BNE NOT_CONTACT
	LDA !HP_MARIO
	CMP #!GUTS_POWER
	BCC TKTK
	BEQ TKTK
	LDA #$04
	STA $1DF9
	LDA !HP_MARIO
	SEC
	SBC #!GUTS_POWER
	STA !HP_MARIO
	LDA #$40
	STA $1497
	RTS
TKTK:
	LDA #$00
	STA !HP_MARIO
	RTS
NOT_CONTACT:
	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP:            db $80,$82,$A0,$A2	;
                    db $84,$86,$A4,$A6	;΂
                    db $88,$8A,$A8,$AA	;
                    db $C0,$C2,$E0,$E2	;
                    db $C8,$CA,$E8,$EA	;
                    db $C4,$C6,$E4,$E6	;

X_OFFSET:           db $08,$F8,$08,$F8,$F8,$08,$F8,$08

Y_OFFSET:           db $F0,$F0,$00,$00

SUB_GFX:            %GetDrawInfo()
                    LDA $157C,x
                    ASL A
                    ASL A
                    STA $02
                    LDA $1504,x
                    ASL A
                    ASL A
                    STA $03
                    
                    PHX
                    LDX #$03

LOOP_START:         PHX
                    TXA
                    ORA $02
                    TAX
                    LDA X_OFFSET,x
                    CLC
                    ADC $00                 ; \ tile x position = sprite y location ($01)
                    STA $0300,y             ; /
                    PLX


                    LDA Y_OFFSET,x
                    CLC
                    ADC $01                 ; \ tile y position = sprite x location ($00)
                    STA $0301,y             ; /
                    
                    PHX
                    TXA
                    ORA $03
                    TAX
                    LDA TILEMAP,x
                    STA $0302,y 
                    PLX
                    
                    PHX
                    LDX $15E9
                    LDA $15F6,x             ; tile properties xyppccct, format
                    LDX $02                 ; \ if direction == 0...
                    BNE NO_FLIP             ;  |
                    ORA #$40                ; /    ...flip tile
NO_FLIP:            ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
                    PLX
                    INY                     ; \ increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ; /    ...so increment 4 times
                    DEX
                    BPL LOOP_START

                    PLX
                    LDY #$02                ; \ 460 = 2 (all 16x16 tiles)
                    LDA #$03                ;  | A = (number of tiles drawn - 1)
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; CHECK_FIREBALL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHECK_FIREBALL:
	PHX				; push x and y
	PHY
	LDY #$00		; reset fireball index
TRYFIRE:
	LDA $1713,y
	BEQ NOTHING
	LDA $1727,y   	; Store fireball locations
	SEC
	SBC #$02
	STA $00
	LDA $173B,y
	SBC #$00
	STA $08
	LDA #$0C
	STA $02
	LDA $171D,y
	SEC
	SBC #$04
	STA $01
	LDA $1731,y
	SBC #$00
	STA $09
	LDA #$13		; clipping related???
	STA $03
	PHY				; push fireball index
	JSL $03B69F 	; get sprite clipping
	JSL $03B72B 	; contact
	BCS FOUNDFIRE	; end if found fireball
	PLY				; pull fireball index
NOTHING:
	CPY #$00		; try again for second fireball
	BNE NOFIRE		; if second failed end
	INY
	BRA TRYFIRE
FOUNDFIRE:
	PLY				; pull fireball index
					; Y has fireball index--ldy RAM, stz $1713,y for instant disp, store 1 for hit something
	PLX				; don't recover Y
	PLX				; pull X
	LDA #$01		; bne to branch if fireball found
	RTS
NOFIRE:
	PLY				; pull x and y
	PLX
	LDA #$00		; beq to branch if fireball not found
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; aiming routine
; input: accumulator should be set to total speed (x+y)
; output: $00 = y speed, $01 = x speed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AIMING:
    STA $01
    PHX                     ;\ preserve sprite indexes of Magikoopa and magic
    PHY                     ;/
    %SubVertPos()           ; $0E = vertical distance to Mario
    STY $02                 ; $02 = vertical direction to Mario
    LDA $0F                 ;\ $0C = vertical distance to Mario, positive
    BPL AIMING2             ; |
        EOR #$FF            ; |
        CLC
        ADC #$01            ; |
AIMING2:
    STA $0C                 ;/
    %SubHorzPos()           ; $0F = horizontal distance to Mario
    STY $03                 ; $03 = horizontal direction to Mario
    LDA $0E                 ;\ $0D = horizontal distance to Mario, positive
    BPL AIMING3                   ; |
        EOR #$FF            ; |
        CLC
        ADC #$01      ; |
AIMING3:
    STA $0D
    LDY #$00
    LDA $0D                 ;\ if vertical distance less than horizontal distance,
    CMP $0C                 ; |
    BCS AIMING4                   ;/ branch
        INY                 ; set y register
        PHA                 ;\ switch $0C and $0D
        LDA $0C             ; |
        STA $0D             ; |
        PLA                 ; |
        STA $0C             ;/
AIMING4:
    STZ $0B                 ;\ zero out $00 and $0B
    STZ $00                 ;/
    LDX $01                 ;\ divide $0C by $0D?
AIMING5:
    LDA $0B                 ; |\ if $0C + loop counter is less than $0D,
    CLC
    ADC $0C           ; | |
    CMP $0D                 ; | |
    BCC AIMING6                   ; |/ branch
        SBC $0D             ; | else, subtract $0D
        INC $00             ; | and increase $00
AIMING6:
    STA $0B                 ; |
    DEX                     ; |\ if still cycles left to run,
    BNE AIMING5                   ;/ / go to start of loop
    TYA                     ;\ if $0C and $0D was not switched,
    BEQ AIMING7                   ;/ branch
        LDA $00             ;\ else, switch $00 and $01
        PHA                 ; |
        LDA $01             ; |
        STA $00             ; |
        PLA                 ; |
        STA $01             ;/
AIMING7:
    LDA $00                 ;\ if horizontal distance was inverted,
    LDY $02                 ; | invert $00
    BEQ AIMING8                   ; |
        EOR #$FF            ; |
        CLC
        ADC #$01      ; |
        STA $00             ;/
AIMING8:
    LDA $01                 ;\ if vertical distance was inverted,
    LDY $03                 ; | invert $01
    BEQ AIMING9                   ; |
        EOR #$FF            ; |
        CLC
        ADC #$01      ; |
        STA $01             ;/
AIMING9:
    PLY                     ;\ retrieve Magikoopa and magic sprite indexes
    PLX                     ;/
    RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate_block
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DELETE_BLK:
	LDA #$10	
	STA $9A
	LDA #$00	
	STA $9B
	LDA #$E0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.w #$0025
	%ChangeMap16()
	SEP #$30
	LDA #$F0	
	STA $98
	REP #$30
	LDA.w #$0025
	%ChangeMap16()
	SEP #$30
	LDA #$00	
	STA $98
	LDA #$01	
	STA $99
	REP #$30
	LDA.w #$0025
	%ChangeMap16()
	SEP #$30
	LDA #$10	
	STA $98
	REP #$30
	LDA.w #$0025
	%ChangeMap16()
	SEP #$30
	LDA #$20	
	STA $98
	REP #$30
	LDA.w #$0025
	%ChangeMap16()
	SEP #$30
	LDA #$20	
	STA $98
	LDA #$E0	
	STA $9A
	REP #$30
	LDA.w #$0025
	%ChangeMap16()
	SEP #$30
	LDA #$10	
	STA $98
	REP #$30
	LDA.w #$0025
	%ChangeMap16()
	SEP #$30
	LDA #$00	
	STA $98
	REP #$30
	LDA.w #$0025
	%ChangeMap16()
	SEP #$30
	LDA #$F0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.w #$0025
	%ChangeMap16()
	SEP #$30
	LDA #$E0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.w #$0025
	%ChangeMap16()
	SEP #$30
	RTS
	
SET_HP_BLK:
	LDA #$10	
	STA $9A
	LDA #$00	
	STA $9B
	LDA #$E0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.w #$36FD  
	%ChangeMap16()
	SEP #$30
	LDA #$F0	
	STA $98
	REP #$30
	LDA.w #$36F8  
	%ChangeMap16()
	SEP #$30
	LDA #$00	
	STA $98
	LDA #$01	
	STA $99
	REP #$30
	LDA.w #$36F8  
	%ChangeMap16()
	SEP #$30
	LDA #$10	
	STA $98
	REP #$30
	LDA.w #$36F8  
	%ChangeMap16()
	SEP #$30
	LDA #$20	
	STA $98
	REP #$30
	LDA.w #$36FE  
	%ChangeMap16()
	SEP #$30
	LDA #$20	
	STA $98
	LDA #$E0	
	STA $9A
	REP #$30
	LDA.w #$36EE  
	%ChangeMap16()
	SEP #$30
	LDA #$10	
	STA $98
	REP #$30
	LDA.w #$36E0  
	%ChangeMap16()
	SEP #$30
	LDA #$00	
	STA $98
	REP #$30
	LDA.w #$36E0  
	%ChangeMap16()
	SEP #$30
	LDA #$F0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.w #$36E0  
	%ChangeMap16()
	SEP #$30
	LDA #$E0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.w #$36E9  
	%ChangeMap16()
	SEP #$30
	RTS

SET_MARIO_BLK:
	LDA !HP_MARIO
	CMP #$08
	BCS LABEL08
	PHY
	LDY #$00
	JSR RESTS
	;0-7
	LDA #$00		
	STA $98
	LDA #$01		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F0  
	%ChangeMap16()
	SEP #$30
	
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F0  
	%ChangeMap16()
	SEP #$30
	
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F9  
	%ChangeMap16()
	SEP #$30
	
	
	PLY
	RTS
LABEL08:

	LDA #$10		
	STA $98
	LDA #$01		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F8  
	%ChangeMap16()
	SEP #$30
	
	LDA !HP_MARIO
	CMP #$10
	BCS LABEL10
	PHY
	LDY #$01
	JSR RESTS
	;08-0F
	
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F0  
	%ChangeMap16()
	SEP #$30
	
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F9  
	%ChangeMap16()
	SEP #$30
	
	
	
	PLY
	RTS
LABEL10:
	LDA #$00		
	STA $98
	LDA #$01		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F8  
	%ChangeMap16()
	SEP #$30
	
	LDA !HP_MARIO
	CMP #$18
	BCS LABEL18
	PHY
	LDY #$02
	JSR RESTS
	
	;10-17
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F9  
	%ChangeMap16()
	SEP #$30
	
	
	
	PLY
	RTS
LABEL18:
	LDA #$00		
	STA $98
	LDA #$01		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F8  
	%ChangeMap16()
	SEP #$30
	
	LDA !HP_MARIO
	CMP #$1C
	BCS LABEL1C
	PHY
	LDY #$03
	JSR RESTS4
	;18-1B
	;()
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F8  
	%ChangeMap16()
	SEP #$30
	PLY
	;()
	RTS
LABEL1C:
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F8  
	%ChangeMap16()
	SEP #$30
	RTS
	
	
RESTS:
	LDA !HP_MARIO
	AND #$07
	CMP #$01
	BEQ REST_1
	CMP #$02
	BEQ REST_2
	CMP #$03
	BEQ REST_3
	CMP #$04
	BEQ REST_4
	CMP #$05
	BEQ REST_5
	CMP #$06
	BEQ REST_6
	CMP #$07
	BEQ REST_7
	CMP #$00
	BEQ REST_0
REST_1: JMP REST1
REST_2: JMP REST2
REST_3: JMP REST3
REST_4: JMP REST4
REST_5: JMP REST5
REST_6: JMP REST6
REST_7: JMP REST7
REST_0: JMP REST0
HP_Y:  db $10,$00,$F0,$E0
HP_Y2: db $01,$01,$00,$00
REST1:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36F1  
	%ChangeMap16()
	SEP #$30
	RTS

REST2:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36F2  
	%ChangeMap16()
	SEP #$30
	RTS

REST3:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36F3  
	%ChangeMap16()
	SEP #$30
	RTS

REST4:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36F4  
	%ChangeMap16()
	SEP #$30
	RTS

REST5:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36F5  
	%ChangeMap16()
	SEP #$30
	RTS

REST6:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36F6  
	%ChangeMap16()
	SEP #$30
	RTS

REST7:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36F7  
	%ChangeMap16()
	SEP #$30
	RTS

REST0:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36F0  
	%ChangeMap16()
	SEP #$30
	RTS

RESTS4:
	LDA !HP_MARIO
	AND #$03
	CMP #$01
	BEQ REST_41
	CMP #$02
	BEQ REST_42
	CMP #$03
	BEQ REST_43
	CMP #$00
	BEQ REST_40
REST_41: JMP REST41
REST_42: JMP REST42
REST_43: JMP REST43
REST_40: JMP REST40
REST41:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36FA  
	%ChangeMap16()
	SEP #$30
	RTS
REST42:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36FB  
	%ChangeMap16()
	SEP #$30
	RTS
REST43:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36FC  
	%ChangeMap16()
	SEP #$30
	RTS
REST40:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36F9  
	%ChangeMap16()
	SEP #$30
	RTS


SET_BOSS_BLK:
	LDA !HP_BOSS,x
	CMP #$08
	BCS LABEL08B
	PHY
	LDY #$00
	JSR RESTSB
	;0-7
	LDA #$00		
	STA $98
	LDA #$01		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36E0  
	%ChangeMap16()
	SEP #$30
	
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36E0  
	%ChangeMap16()
	SEP #$30
	
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36E9  
	%ChangeMap16()
	SEP #$30
	
	
	PLY
	RTS
LABEL08B:

	LDA #$10		
	STA $98
	LDA #$01		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36E8  
	%ChangeMap16()
	SEP #$30
	
	LDA !HP_BOSS,x
	CMP #$10
	BCS LABEL10B
	PHY
	LDY #$01
	JSR RESTSB
	;08-0F
	
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36E0  
	%ChangeMap16()
	SEP #$30
	
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36E9  
	%ChangeMap16()
	SEP #$30
	
	
	
	PLY
	RTS
LABEL10B:
	LDA #$00
	STA $98
	LDA #$01
	STA $99
	LDA #$E0
	STA $9A
	LDA #$00
	STA $9B
	REP #$30
	LDA.w #$36E8
	%ChangeMap16()
	SEP #$30
	
	LDA !HP_BOSS,x
	CMP #$18
	BCS LABEL18B
	PHY
	LDY #$02
	JSR RESTSB
	
	;10-17
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36E9  
	%ChangeMap16()
	SEP #$30
	
	
	
	PLY
	RTS
LABEL18B:
	LDA #$00		
	STA $98
	LDA #$01		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36E8  
	%ChangeMap16()
	SEP #$30
	
	LDA !HP_BOSS,x
	CMP #$1C
	BCS LABEL1CB
	PHY
	LDY #$03
	JSR RESTS4B
	;18-1B
	;()
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36E8  
	%ChangeMap16()
	SEP #$30
	PLY
	;()
	RTS
LABEL1CB:
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36E8  
	%ChangeMap16()
	SEP #$30
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36ED  
	%ChangeMap16()
	SEP #$30
	RTS
	
	
RESTSB:
	LDA !HP_BOSS,x
	AND #$07
	CMP #$01
	BEQ REST_1B
	CMP #$02
	BEQ REST_2B
	CMP #$03
	BEQ REST_3B
	CMP #$04
	BEQ REST_4B
	CMP #$05
	BEQ REST_5B
	CMP #$06
	BEQ REST_6B
	CMP #$07
	BEQ REST_7B
	CMP #$00
	BEQ REST_0B
REST_1B: JMP REST1B
REST_2B: JMP REST2B
REST_3B: JMP REST3B
REST_4B: JMP REST4B
REST_5B: JMP REST5B
REST_6B: JMP REST6B
REST_7B: JMP REST7B
REST_0B: JMP REST0B

REST1B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36E1  
	%ChangeMap16()
	SEP #$30
	RTS

REST2B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36E2  
	%ChangeMap16()
	SEP #$30
	RTS

REST3B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36E3  
	%ChangeMap16()
	SEP #$30
	RTS

REST4B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36E4  
	%ChangeMap16()
	SEP #$30
	RTS

REST5B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36E5  
	%ChangeMap16()
	SEP #$30
	RTS

REST6B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36E6  
	%ChangeMap16()
	SEP #$30
	RTS

REST7B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36E7  
	%ChangeMap16()
	SEP #$30
	RTS

REST0B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.w #$36E0 
	%ChangeMap16()
	SEP #$30
	RTS

RESTS4B:
	LDA !HP_BOSS,x
	AND #$03
	CMP #$01
	BEQ REST_41B
	CMP #$02
	BEQ REST_42B
	CMP #$03
	BEQ REST_43B
	CMP #$00
	BEQ REST_40B
REST_41B: JMP REST41B
REST_42B: JMP REST42B
REST_43B: JMP REST43B
REST_40B: JMP REST40B
REST41B:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36EA  
	%ChangeMap16()
	SEP #$30
	RTS
REST42B:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36EB  
	%ChangeMap16()
	SEP #$30
	RTS
REST43B:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36EC  
	%ChangeMap16()
	SEP #$30
	RTS
REST40B:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.w #$36E9  
	%ChangeMap16()
	SEP #$30
	RTS