;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Kbc}̊ (ネbN}) by tan-cos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!SPRITE_NAM	= $01		;<------̃XvCgԍ

!POWER		= $04		;̃_[W

!Y_SP		= !AA
!X_SP		= !B6
!Y_LOW		= !D8
!X_LOW		= !E4
!HP_MARIO	= $0F48
!Y_HIGH		= !14D4
!X_HIGH		= !14E0
!POSE		= !1504
!TOUCH		= !1588		;HFLR
!STATE		= !151C
!TIMER		= !1564
!SP_RAM		= !1594
!FLAG		= !164A

X_RIGHT:	db $40,$40,$30,$30
X_LEFT:		db $C0,$C0,$D0,$D0
Y_SPEED:	db $D0,$00,$E0,$00
SIZE_MAP:	db $16,$00

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	print "INIT ",pc
	RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR START_HB_CODE
	PLB
	RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN:
	RTS
START_HB_CODE:
	JSR SUB_GFX
	LDA $14C8,x
	CMP #$08
	BNE RETURN
	LDA $9D
	BNE RETURN
	%SubOffScreen()
	
	PHY
	LDA !POSE,x
	TAY
	LDA SIZE_MAP,y
	STA $1662,x
	PLY
	
	LDA !STATE,x
	BNE SKIP
	%SubHorzPos()
	TYA
	STA !157C,x
	LDA #$01
	STA !STATE,x
SKIP:
	LDA !POSE,x
	BEQ BIG
	JMP SMALL_LAST
BIG:
	LDA $1588,x
	BNE CRASH
	JMP BIG_LAST
CRASH:
	LDA #$07
	STA $1DFC			;SE:CRASH
	
	LDA #$F8
	STA $00
	LDA #$F0
	STA $01
	LDA #$00
	STA $02
	STA $03
	LDA #!SPRITE_NAM
	SEC
	%SpawnSprite()
	
	LDA #$00
	STA !FLAG,y
	LDA #$01
	STA !POSE,y
	LDA !157C,x
	STA !157C,y
	
	LDA #$08
	STA $00
	LDA #$F0
	STA $01
	LDA #$00
	STA $02
	STA $03
	LDA #!SPRITE_NAM
	SEC
	%SpawnSprite()
	
	LDA #$01
	STA !FLAG,y
	LDA #$01
	STA !POSE,y
	LDA !157C,x
	STA !157C,y
	
	LDA #$F8
	STA $00
	LDA #$00
	STA $01
	LDA #$00
	STA $02
	STA $03
	LDA #!SPRITE_NAM
	SEC
	%SpawnSprite()
	
	LDA #$02
	STA !FLAG,y
	LDA #$01
	STA !POSE,y
	LDA !157C,x
	STA !157C,y
	
	LDA #$08
	STA $00
	LDA #$00
	STA $01
	LDA #$00
	STA $02
	STA $03
	LDA #!SPRITE_NAM
	SEC
	%SpawnSprite()
	LDA #$03
	STA !FLAG,y
	LDA #$01
	STA !POSE,y
	LDA !157C,x
	STA !157C,y

	LDA #$00
	STA $14C8,x
	RTS
BIG_LAST:
	JSL $01802A
	JMP TURN
SMALL_LAST:
	LDA !157C,x
	BEQ LABEL_DIR
	PHY
	LDA !FLAG,x
	TAY
	LDA X_LEFT,y
	STA !X_SP,x
	LDA Y_SPEED,y
	STA !Y_SP,x
	PLY
	BRA LABEL_SMALL
LABEL_DIR:
	PHY
	LDA !FLAG,x
	TAY
	LDA X_RIGHT,y
	STA !X_SP,x
	LDA Y_SPEED,y
	STA !Y_SP,x
	PLY
LABEL_SMALL:
	JSL $018022
	JSL $01801A
	JMP TURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  damage routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TURN:
	JSL $01A7DC	
	BCC NOT_CONTACT
	LDA $1497
	BNE NOT_CONTACT
	LDA !HP_MARIO
	CMP #$04
	BCC TKTK
	BEQ TKTK
	LDA #$04
	STA $1DF9
	LDA !HP_MARIO
	SEC
	SBC #$04
	STA !HP_MARIO
	LDA #$40
	STA $1497
	RTS
TKTK:
	LDA #$00
	STA !HP_MARIO
	RTS
NOT_CONTACT:
	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILENAM:	db $03,$00

TILEMAP:	db $CC,$CE,$EC,$EE
			db $8E,$AE

X_OFFSET:	db $08,$F8,$08,$F8,$F8,$08,$F8,$08
			db $00,$00,$00,$00,$00,$00,$00,$00

Y_OFFSET:	db $F0,$F0,$00,$00
			db $00,$00

SUB_GFX:            %GetDrawInfo()
	LDA !157C,x
	ASL A
	ASL A
	STA $02			;$02 = 
	LDA !POSE,x
	STA $05			;$05 = |[Y(TILENAMp)
	ASL A
	ASL A
	STA $03			;$03 = |[Y
	ASL A
	STA $06			;$06 = |[Y(X_OFFSETp)
	LDA #$00
	STA $04
	LDA $05
	BEQ NO_ANIME
	LDA $14
	AND #$08
	LSR A
	LSR A
	LSR A
	STA $04			;$04 = t[JE^
NO_ANIME:
	PHX
	
	PHY
	LDA $05
	TAY
	LDA TILENAM,y
	STA $07
	TAX
	PLY

LOOP_START:          PHX
	TXA
	ORA $02
	ORA $06
	TAX
	LDA X_OFFSET,x
	CLC
	ADC $00                 ; \ tile x position = sprite y location ($01)
	STA $0300,y             ; /
	PLX

	PHX
	TXA
	ORA $03
	TAX
	LDA Y_OFFSET,x
	CLC
	ADC $01                 ; \ tile y position = sprite x location ($00)
	STA $0301,y             ; /
	PLX

	PHX
	TXA
	ORA $03
	ORA $04
	TAX
	LDA TILEMAP,x
	STA $0302,y 
	PLX
	
	PHX
	LDX $15E9
	LDA $15F6,x             ; tile properties xyppccct, format
	LDX $02                 ; \ if direction == 0...
	BNE NO_FLIP             ;  |
	ORA #$40                ; /    ...flip tile
NO_FLIP:             ORA $64                 ; add in tile priority of level
	STA $0303,y             ; store tile properties
	PLX
	INY	 ; \ increase index to sprite tile map ($300)...
	INY	 ;  |    ...we wrote 1 16x16 tile...
	INY	 ;  |    ...sprite OAM is 8x8...
	INY	 ; /    ...so increment 4 times
	DEX
	BPL LOOP_START

	PLX
	LDY #$02
	LDA $07
	JSL $01B7B3
	RTS