;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Kbc} (ネbN}) by tan-cos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_MARIO		= $94
Y_MARIO		= $96
Y_SP		= $AA
X_SP		= $B6
Y_LOW		= $D8
X_LOW		= $E4
HP_MARIO	= $0F48
Y_HIGH		= $14D4
X_HIGH		= $14E0
POSE		= $1504
STATE		= $151C
HP_BOSS		= $1528
FLAG		= $1534
DAMAGE		= $1558
TIMER		= $1564
TOUCH		= $1588		;HFLR
SP_RAM		= $1594
FLAG2		= $15B8
OLD_HP		= $1626
SET_YL		= $178B
SET_YH		= $1793
SET_XL		= $179B
SET_XH		= $17A3
SET_SP  	= $187B

SPRITE		= $01		;΃XvCgԍ

Y_SPEED		= $A0		;Wv͂

FIRE_DAMAGE	= $01		;t@CAɂ_[W

GUTS_POWER	= $04		;Kbc}̍U

EARTH_TIME	= $40		;nk^C}[


X_SPEED		dcb $10,$F0,$00,$00	;ړx


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	dcb "INIT"
	LDA #$03
	STA $19		;power
	STZ $0DC2
	LDA #$1C
	STA HP_MARIO
	STA !HP_BOSS,x
	LDA #$03
	STA POSE,x
	RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	dcb "MAIN"
	PHB                     ; \
	PHK                     ;  | main sprite function, just calls local subroutine
	PLB                     ;  |
	JSR START_HB_CODE       ;  |
	PLB                     ;  |
	RTL                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN
	RTS
START_HB_CODE
	JSR SUB_GFX
	LDA $14C8,x
	CMP #$08
	BNE RETURN
	LDA $9D
	BNE RETURN
	JSR SUB_OFF_SCREEN_X0
	
	LDA HP_MARIO
	BNE SKIP_TKTK
	LDA FLAG2,x
	BNE DELETE_HP
	JSR SET_MARIO_BLK
	JSL $00F606
	BRA SKIP_TKTK
DELETE_HP:
	JSR DELETE_BLK
SKIP_TKTK:

	LDA $1540,x
	BEQ NOT_BOMBER
	CMP #$01
	BEQ DELETE
	LDA $167A,x
	AND #$7F
	STA $167A,x
	PHB 
	LDA #$02
	PHA
	PLB
	JSL $028086
	PLB
	RTS
DELETE
	JSR GEN_NORMAL
	STZ $14C8,x
	RTS
NOT_BOMBER
	LDA STATE,x
	CMP #$03
	BCC SKIP_TIWN
	LDA HP_BOSS,x
	BNE SKIP_TIWN
	LDA $1540,x
	BNE SKIP_TIWN
	
	LDA #$40
	STA $1540,x
	LDA #$16
	STA $1DFC
	LDA #$60
	STA $1497
	LDA #$01
	STA FLAG2,x
	JSR DELETE_BLK
SKIP_TIWN
	LDA STATE,x
	CMP #$03
	BCC SKIP_MARIO_BLK
	LDA OLD_HP,x
	CMP HP_MARIO
	BEQ SKIP_MARIO_BLK
	LDA FLAG2,x
	BNE SKIP_MARIO_BLK
	LDA HP_MARIO
	STA OLD_HP,x
	JSR SET_MARIO_BLK
SKIP_MARIO_BLK:
	LDA X_LOW,x
	CMP X_MARIO
	BCS LOOK_MARIO
	LDA #$00
	STA $157C,x
	BRA LOOK_MARIO_END
LOOK_MARIO:
	LDA #$01
	STA $157C,x
LOOK_MARIO_END:
START:
	LDA TIMER,x
	BEQ NO_TIME
	JMP TURN
NO_TIME:
	LDA STATE,x
	CMP #$03
	BCS WAIT_HP
	LDA #$0D
	STA $71
	LDA TOUCH,x
	AND #$04
	BNE ON_GND
	JMP TURN
WAIT_HP:
	JMP LAST_WAIT_HP
ON_GND:
	LDA STATE,x
	CMP #$01
	BCS HP_COUNT
	LDA #$01
	STA STATE,x
	LDA #$00
	STA POSE,x
	LDA #$16
	STA $1DFC
	LDA #$00
	STA X_SP,x
	LDA #$30
	STA $1887
	LDA #$20
	STA TIMER,x
	JMP TURN
HP_COUNT:
	LDA STATE,x
	CMP #$02
	BCS HP_END
	JSR SET_HP_BLK
	LDA #$02
	STA STATE,x
	LDA #$04
	STA POSE,x
	LDA #$08
	STA TIMER,x
	JMP TURN
HP_END:
	LDA STATE,x
	CMP #$03
	BCS LAST_WAIT_HP
	LDA HP_BOSS,x
	CMP #$1C
	BCS END_COUNT_HP
	LDA HP_BOSS,x
	INC A
	STA HP_BOSS,x
	JSR SET_BOSS_BLK
	LDA #$01
	STA $1DFC
	LDA #$02
	STA TIMER,x
	JMP TURN
END_COUNT_HP:
	LDA #$03
	STA STATE,x
	LDA #$40
	STA TIMER,x
	JMP TURN
LAST_WAIT_HP:
	LDA FLAG2,x
	BNE WAIT_START
	JSR SET_MARIO_BLK
WAIT_START:
	LDA STATE,x
	CMP #$04
	BCS JUMP_START
	LDA #$00
	STA $71			;}I~
	LDA #$02
	STA POSE,x
	JSL $01ACF9		;
	LDA $148D
	AND #$01
	BEQ NO_ROCK_FLAG
	LDA #$01
	STA FLAG,x
	BRA SKIP_SET_X
NO_ROCK_FLAG
	LDA TOUCH,x
	AND #$01
	BEQ JUMP1
	LDA #$01
	BRA JUMP4
JUMP1
	LDA TOUCH,x
	AND #$02
	BEQ JUMP2
	LDA #$00
	BRA JUMP4
JUMP2
	LDA $148E
	AND #$01
JUMP4
	PHY
	TAY
	LDA X_SPEED,y
	STA X_SP,x
	PLY
SKIP_SET_X
	LDA #$C0
	STA Y_SP,x
	LDA #$03
	STA POSE,x
	LDA #$04
	STA STATE,x
	JMP TURN
JUMP_START:
	LDA STATE,x
	CMP #$05
	BCS JUMP_UP
	LDA #$05
	STA STATE,x
	JMP TURN
JUMP_UP:
	LDA STATE,x
	CMP #$06
	BCS JUMP_DOWN
	LDA TOUCH,x
	AND #$03
	BEQ NO_STOP2
	LDA #$00
	STA X_SP,x
NO_STOP2

	LDA TOUCH,x
	AND #$04
	BEQ IN_AIR
	LDA #$00
	STA POSE,x
	LDA #$16
	STA $1DFC
	LDA #$00
	STA X_SP,x
	LDA #EARTH_TIME
	STA $1887
	LDA $77
	AND #$04
	BEQ MARIO_IN_AIR
	LDA #EARTH_TIME
	STA $18BD
MARIO_IN_AIR:
	LDA FLAG,x
	BEQ NO_FLAG
	LDA #$10
	STA STATE,x
	JMP TURN
NO_FLAG:
	LDA #$06
	STA STATE,x
IN_AIR:
	JMP TURN
JUMP_DOWN:
	LDA STATE,x
	CMP #$07
	BCS WAIT01
	LDA #$07
	STA STATE,x
	LDA #$00
	STA POSE,x
	LDA #$10
	STA TIMER,x
	JMP TURN
WAIT01:
	LDA STATE,x
	CMP #$08
	BCS WAIT02
	LDA #$08
	STA STATE,x
	LDA #$01
	STA POSE,x
	LDA #$10
	STA TIMER,x
	JMP TURN
WAIT02:
	LDA STATE,x
	CMP #$09
	BCS WAIT03
	LDA #$09
	STA STATE,x
	LDA #$00
	STA POSE,x
	LDA #$10
	STA TIMER,x
	JMP TURN
WAIT03:
	LDA STATE,x
	CMP #$0A
	BCS WAIT04
	LDA #$0A
	STA STATE,x
	LDA #$01
	STA POSE,x
	LDA #$10
	STA TIMER,x
	JMP TURN
WAIT04:
	LDA STATE,x
	CMP #$0B
	BCS ROCK_FALL
	LDA #$03
	STA STATE,x
	LDA #$00
	STA POSE,x
	LDA #$10
	STA TIMER,x
	JMP TURN
ROCK_FALL:
	LDA STATE,x
	CMP #$11
	BCS ROCK_CATCH
	LDA #$04
	STA POSE,x
	LDA #SPRITE
	STA SET_SP,x
	LDA X_LOW,x
	STA SET_XL,x
	LDA X_HIGH,x
	STA SET_XH,x
	LDA Y_LOW,x
	SEC
	SBC #$C0
	STA SET_YL,x
	LDA Y_HIGH,x
	SBC #$00
	STA SET_YH,x
	JSR GEN_CUSTOM
	TYA
	STA SP_RAM,x
	LDA #$11
	STA STATE,x
	JMP TURN
ROCK_CATCH:
	LDA STATE,x
	CMP #$12
	BCS ROCK_THROW_WAIT
	LDA SP_RAM,x
	TAY
	LDA Y_HIGH,x
	CMP Y_HIGH,y
	BNE NO_CATCH
	LDA Y_LOW,x
	SEC
	SBC #$20
	CMP Y_LOW,y
	BCS NO_CATCH
	LDA #$00
	STA Y_SP,y
	LDA #$10
	STA $1DFC
	LDA #$12
	STA STATE,x
NO_CATCH:
	JMP TURN
ROCK_THROW_WAIT:
	LDA STATE,x
	CMP #$13
	BCS ROCK_THROW
	LDA #$13
	STA STATE,x
	LDA #$20
	STA TIMER,x
ROCK_THROW:
	LDA STATE,x
	CMP #$14
	BCS LAST_WAIT_ROCK
	LDA #$40
	JSR AIMING
	LDA SP_RAM,x
	TAY
	LDA $01
	STA X_SP,y
	LDA $00
	STA Y_SP,y
	LDA $157C,x
	STA $157C,y
	LDA #$03
	STA $1DF9
	LDA #$05
	STA POSE,x
	LDA #$14
	STA STATE,x
	LDA #$10
	STA TIMER,x
	JMP TURN
LAST_WAIT_ROCK
	LDA #$00
	STA FLAG,x
	STA POSE,x
	LDA #$03
	STA STATE,x
	LDA #$20
	STA TIMER,x
	JMP TURN
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  3rd routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TURN:
	JSL $01802A
	JSR CHECK_FIREBALL
	BEQ SKIP_FIRE
	JMP MARIO_FIRE_WIN
SKIP_FIRE:
	JSL $01A7DC
	BCC NOT_CONTACT
;	LDA $7D
;	CMP #$10
;	BMI BOSS_WIN
	BRA BOSS_WIN
MARIO_WIN:
	LDA DAMAGE,x
	BNE NOT_CONTACT
	JSL $01AA33
	LDA #$28
	STA $1DFC
	LDA HP_BOSS,x
	DEC A
	DEC A
	STA HP_BOSS,x
	LDA #$40
	STA DAMAGE,x
	JSR SET_BOSS_BLK
	RTS
MARIO_FIRE_WIN:
	LDA DAMAGE,x
	BNE NOT_CONTACT
	LDA HP_BOSS,x
	CMP #FIRE_DAMAGE
	BCC TIWN
	BEQ TIWN
	LDA #$28
	STA $1DFC
	LDA HP_BOSS,x
	SEC
	SBC #FIRE_DAMAGE
	STA HP_BOSS,x
	LDA #$40
	STA DAMAGE,x
	JSR SET_BOSS_BLK
	RTS
TIWN:
	LDA #$00
	STA HP_BOSS,x
	RTS
BOSS_WIN:
	LDA $1497
	BNE NOT_CONTACT
	LDA HP_MARIO
	CMP #GUTS_POWER
	BCC TKTK
	BEQ TKTK
	LDA #$04
	STA $1DF9
	LDA HP_MARIO
	SEC
	SBC #GUTS_POWER
	STA HP_MARIO
	LDA #$40
	STA $1497
	RTS
TKTK:
	LDA #$00
	STA HP_MARIO
	RTS
NOT_CONTACT:
	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP             dcb $00,$02,$20,$22
                    dcb $04,$06,$24,$26
                    dcb $08,$0A,$28,$2A
                    dcb $0C,$0E,$2C,$2E
                    dcb $40,$42,$60,$62
                    dcb $44,$46,$64,$66

X_OFFSET:           dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08

Y_OFFSET:           dcb $F0,$F0,$00,$00

SUB_GFX:             JSR GET_DRAW_INFO
                    LDA $157C,x
                    ASL A
                    ASL A
                    STA $02
                    LDA $1504,x
                    ASL A
                    ASL A
                    STA $03
                    
                    PHX
                    LDX #$03

LOOP_START:         PHX
                    TXA
                    ORA $02
                    TAX
                    LDA X_OFFSET,x
                    CLC
                    ADC $00                 ; \ tile x position = sprite y location ($01)
                    STA $0300,y             ; /
                    PLX


                    LDA Y_OFFSET,x
                    CLC
                    ADC $01                 ; \ tile y position = sprite x location ($00)
                    STA $0301,y             ; /
                    
                    PHX
                    TXA
                    ORA $03
                    TAX
                    LDA TILEMAP,x
                    STA $0302,y 
                    PLX
                    
                    PHX
                    LDX $15E9
                    LDA $15F6,x             ; tile properties xyppccct, format
                    LDX $02                 ; \ if direction == 0...
                    BNE NO_FLIP             ;  |
                    ORA #$40                ; /    ...flip tile
NO_FLIP:            ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
                    PLX
                    INY                     ; \ increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ; /    ...so increment 4 times
                    DEX
                    BPL LOOP_START

                    PLX
                    LDY #$02                ; \ 460 = 2 (all 16x16 tiles)
                    LDA #$03                ;  | A = (number of tiles drawn - 1)
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN67
	RTS     
GEN_NORMAL
	JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
	BMI RETURN67            ; / after: Y has index of sprite being generated

	LDA #$08                ; \ set sprite status for new sprite
	STA $14C8,y             ; /XvCg̏Ԃݒ


	LDA #$4A             ;ɐXvCgԍ
	STA $009E,y
                    
	LDA $E4,x               ;\ set x position for new sprite
	STA $00E4,y             ;  |XvCgxW
	LDA $14E0,x             ;  |̗̏ꍇAeXvCgƓʒuɐĂ
	STA $14E0,y             ; /

	LDA $D8,x               ;\ set y position for new sprite
	STA $00D8,y             ;  |XvCgyW
	LDA $14D4,x             ;  |̗̏ꍇAeXvCgƓʒuɐĂ
	STA $14D4,y             ; /

	LDA $157C,x             ;  |eXvCgƓ
	STA $157C,y             ; /

	PHX
	TYX
	JSL $07F7D2             ;  
	PLX
	RTS         
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RETURN68:
	RTS
GEN_CUSTOM:
	JSL $02A9DE
	BMI RETURN68
	LDA #$08
	STA $14C8,y
	LDA SET_SP,x
	PHX
	TYX
	STA $7FAB9E,x
	PLX
	LDA SET_XL,x
	STA $00E4,y
	LDA #$00
	STA $14E0,y
	LDA SET_YL,x
	STA $00D8,y
	LDA SET_YH,x
	STA $14D4,y
	LDA $157C,x
	STA $157C,y
	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7
	LDA #$88
	STA $7FAB10,x
	PLX
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; CHECK_FIREBALL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHECK_FIREBALL:
	PHX				; push x and y
	PHY
	LDY #$00		; reset fireball index
TRYFIRE:
	LDA $1713,y
	BEQ NOTHING
	LDA $1727,y   	; Store fireball locations
	SEC
	SBC #$02
	STA $00
	LDA $173B,y
	SBC #$00
	STA $08
	LDA #$0C
	STA $02
	LDA $171D,y
	SEC
	SBC #$04
	STA $01
	LDA $1731,y
	SBC #$00
	STA $09
	LDA #$13		; clipping related???
	STA $03
	PHY				; push fireball index
	JSL $03B69F 	; get sprite clipping
	JSL $03B72B 	; contact
	BCS FOUNDFIRE	; end if found fireball
	PLY				; pull fireball index
NOTHING:
	CPY #$00		; try again for second fireball
	BNE NOFIRE		; if second failed end
	INY
	BRA TRYFIRE
FOUNDFIRE:
	PLY				; pull fireball index
					; Y has fireball index--ldy RAM, stz $1713,y for instant disp, store 1 for hit something
	PLX				; don't recover Y
	PLX				; pull X
	LDA #$01		; bne to branch if fireball found
	RTS
NOFIRE:
	PLY				; pull x and y
	PLX
	LDA #$00		; beq to branch if fireball not found
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; aiming routine
; input: accumulator should be set to total speed (x+y)
; output: $00 = y speed, $01 = x speed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AIMING:
    STA $01
    PHX                     ;\ preserve sprite indexes of Magikoopa and magic
    PHY                     ;/
    JSR SUB_VERT_POS        ; $0E = vertical distance to Mario
    STY $02                 ; $02 = vertical direction to Mario
    LDA $0F                 ;\ $0C = vertical distance to Mario, positive
    BPL AIMING2                   ; |
        EOR #$FF            ; |
        CLC
        ADC #$01      ; |
AIMING2:
    STA $0C                 ;/
    JSR SUB_HORZ_POS        ; $0F = horizontal distance to Mario
    STY $03                 ; $03 = horizontal direction to Mario
    LDA $0E                 ;\ $0D = horizontal distance to Mario, positive
    BPL AIMING3                   ; |
        EOR #$FF            ; |
        CLC
        ADC #$01      ; |
AIMING3:
    STA $0D
    LDY #$00
    LDA $0D                 ;\ if vertical distance less than horizontal distance,
    CMP $0C                 ; |
    BCS AIMING4                   ;/ branch
        INY                 ; set y register
        PHA                 ;\ switch $0C and $0D
        LDA $0C             ; |
        STA $0D             ; |
        PLA                 ; |
        STA $0C             ;/
AIMING4:
    STZ $0B                 ;\ zero out $00 and $0B
    STZ $00                 ;/
    LDX $01                 ;\ divide $0C by $0D?
AIMING5:
    LDA $0B                 ; |\ if $0C + loop counter is less than $0D,
    CLC
    ADC $0C           ; | |
    CMP $0D                 ; | |
    BCC AIMING6                   ; |/ branch
        SBC $0D             ; | else, subtract $0D
        INC $00             ; | and increase $00
AIMING6:
    STA $0B                 ; |
    DEX                     ; |\ if still cycles left to run,
    BNE AIMING5                   ;/ / go to start of loop
    TYA                     ;\ if $0C and $0D was not switched,
    BEQ AIMING7                   ;/ branch
        LDA $00             ;\ else, switch $00 and $01
        PHA                 ; |
        LDA $01             ; |
        STA $00             ; |
        PLA                 ; |
        STA $01             ;/
AIMING7:
    LDA $00                 ;\ if horizontal distance was inverted,
    LDY $02                 ; | invert $00
    BEQ AIMING8                   ; |
        EOR #$FF            ; |
        CLC
        ADC #$01      ; |
        STA $00             ;/
AIMING8:
    LDA $01                 ;\ if vertical distance was inverted,
    LDY $03                 ; | invert $01
    BEQ AIMING9                   ; |
        EOR #$FF            ; |
        CLC
        ADC #$01      ; |
        STA $01             ;/
AIMING9:
    PLY                     ;\ retrieve Magikoopa and magic sprite indexes
    PLX                     ;/
    RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate_block
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DELETE_BLK:
	LDA #$10	
	STA $9A
	LDA #$00	
	STA $9B
	LDA #$E0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.W #$0025
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$F0	
	STA $98
	REP #$30
	LDA.W #$0025
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$00	
	STA $98
	LDA #$01	
	STA $99
	REP #$30
	LDA.W #$0025
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$10	
	STA $98
	REP #$30
	LDA.W #$0025
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$20	
	STA $98
	REP #$30
	LDA.W #$0025
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$20	
	STA $98
	LDA #$E0	
	STA $9A
	REP #$30
	LDA.W #$0025
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$10	
	STA $98
	REP #$30
	LDA.W #$0025
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$00	
	STA $98
	REP #$30
	LDA.W #$0025
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$F0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.W #$0025
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$E0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.W #$0025
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS
	
SET_HP_BLK:
	LDA #$10	
	STA $9A
	LDA #$00	
	STA $9B
	LDA #$E0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.W #$36FD  
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$F0	
	STA $98
	REP #$30
	LDA.W #$36F8  
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$00	
	STA $98
	LDA #$01	
	STA $99
	REP #$30
	LDA.W #$36F8  
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$10	
	STA $98
	REP #$30
	LDA.W #$36F8  
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$20	
	STA $98
	REP #$30
	LDA.W #$36FE  
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$20	
	STA $98
	LDA #$E0	
	STA $9A
	REP #$30
	LDA.W #$36EE  
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$10	
	STA $98
	REP #$30
	LDA.W #$36E0  
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$00	
	STA $98
	REP #$30
	LDA.W #$36E0  
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$F0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.W #$36E0  
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$E0	
	STA $98
	LDA #$00	
	STA $99
	REP #$30
	LDA.W #$36E9  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

SET_MARIO_BLK:
	LDA HP_MARIO
	CMP #$08
	BCS LABEL08
	PHY
	LDY #$00
	JSR RESTS
	;0-7
	LDA #$00		
	STA $98
	LDA #$01		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F0  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F0  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F9  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	
	PLY
	RTS
LABEL08:

	LDA #$10		
	STA $98
	LDA #$01		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F8  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA HP_MARIO
	CMP #$10
	BCS LABEL10
	PHY
	LDY #$01
	JSR RESTS
	;08-0F
	
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F0  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F9  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	
	
	PLY
	RTS
LABEL10:
	LDA #$00		
	STA $98
	LDA #$01		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F8  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA HP_MARIO
	CMP #$18
	BCS LABEL18
	PHY
	LDY #$02
	JSR RESTS
	
	;10-17
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F9  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	
	
	PLY
	RTS
LABEL18:
	LDA #$00		
	STA $98
	LDA #$01		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F8  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA HP_MARIO
	CMP #$1C
	BCS LABEL1C
	PHY
	LDY #$03
	JSR RESTS4
	;18-1B
	;()
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F8  
	JSR SUBL_SET_MAP16
	SEP #$30
	PLY
	;()
	RTS
LABEL1C:
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F8  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS
	
	
RESTS:
	LDA HP_MARIO
	AND #$07
	CMP #$01
	BEQ REST_1
	CMP #$02
	BEQ REST_2
	CMP #$03
	BEQ REST_3
	CMP #$04
	BEQ REST_4
	CMP #$05
	BEQ REST_5
	CMP #$06
	BEQ REST_6
	CMP #$07
	BEQ REST_7
	CMP #$00
	BEQ REST_0
REST_1: JMP REST1
REST_2: JMP REST2
REST_3: JMP REST3
REST_4: JMP REST4
REST_5: JMP REST5
REST_6: JMP REST6
REST_7: JMP REST7
REST_0: JMP REST0
HP_Y:  dcb $10,$00,$F0,$E0
HP_Y2: dcb $01,$01,$00,$00
REST1:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36F1  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST2:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36F2  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST3:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36F3  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST4:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36F4  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST5:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36F5  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST6:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36F6  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST7:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36F7  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST0:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36F0  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

RESTS4:
	LDA HP_MARIO
	AND #$03
	CMP #$01
	BEQ REST_41
	CMP #$02
	BEQ REST_42
	CMP #$03
	BEQ REST_43
	CMP #$00
	BEQ REST_40
REST_41: JMP REST41
REST_42: JMP REST42
REST_43: JMP REST43
REST_40: JMP REST40
REST41:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36FA  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS
REST42:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36FB  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS
REST43:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36FC  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS
REST40:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$10		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36F9  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS


SET_BOSS_BLK:
	LDA HP_BOSS,x
	CMP #$08
	BCS LABEL08B
	PHY
	LDY #$00
	JSR RESTSB
	;0-7
	LDA #$00		
	STA $98
	LDA #$01		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E0  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E0  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E9  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	
	PLY
	RTS
LABEL08B:

	LDA #$10		
	STA $98
	LDA #$01		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E8  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA HP_BOSS,x
	CMP #$10
	BCS LABEL10B
	PHY
	LDY #$01
	JSR RESTSB
	;08-0F
	
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E0  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E9  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	
	
	PLY
	RTS
LABEL10B:
	LDA #$00		
	STA $98
	LDA #$01		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E8  ;^C16xԍ
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA HP_BOSS,x
	CMP #$18
	BCS LABEL18B
	PHY
	LDY #$02
	JSR RESTSB
	
	;10-17
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E9  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	
	
	PLY
	RTS
LABEL18B:
	LDA #$00		
	STA $98
	LDA #$01		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E8  
	JSR SUBL_SET_MAP16
	SEP #$30
	
	LDA HP_BOSS,x
	CMP #$1C
	BCS LABEL1CB
	PHY
	LDY #$03
	JSR RESTS4B
	;18-1B
	;()
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E8  
	JSR SUBL_SET_MAP16
	SEP #$30
	PLY
	;()
	RTS
LABEL1CB:
	LDA #$F0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E8  
	JSR SUBL_SET_MAP16
	SEP #$30
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36ED  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS
	
	
RESTSB:
	LDA HP_BOSS,x
	AND #$07
	CMP #$01
	BEQ REST_1B
	CMP #$02
	BEQ REST_2B
	CMP #$03
	BEQ REST_3B
	CMP #$04
	BEQ REST_4B
	CMP #$05
	BEQ REST_5B
	CMP #$06
	BEQ REST_6B
	CMP #$07
	BEQ REST_7B
	CMP #$00
	BEQ REST_0B
REST_1B: JMP REST1B
REST_2B: JMP REST2B
REST_3B: JMP REST3B
REST_4B: JMP REST4B
REST_5B: JMP REST5B
REST_6B: JMP REST6B
REST_7B: JMP REST7B
REST_0B: JMP REST0B

REST1B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36E1  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST2B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36E2  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST3B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36E3  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST4B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36E4  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST5B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36E5  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST6B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36E6  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST7B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36E7  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

REST0B:
	LDA HP_Y,y		
	STA $98
	LDA HP_Y2,y	
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	
	REP #$30
	LDA.W #$36E0 
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

RESTS4B:
	LDA HP_BOSS,x
	AND #$03
	CMP #$01
	BEQ REST_41B
	CMP #$02
	BEQ REST_42B
	CMP #$03
	BEQ REST_43B
	CMP #$00
	BEQ REST_40B
REST_41B: JMP REST41B
REST_42B: JMP REST42B
REST_43B: JMP REST43B
REST_40B: JMP REST40B
REST41B:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36EA  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS
REST42B:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36EB  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS
REST43B:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36EC  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS
REST40B:
	LDA #$E0		
	STA $98
	LDA #$00		
	STA $99
	LDA #$E0		
	STA $9A
	LDA #$00		
	STA $9B
	REP #$30
	LDA.W #$36E9  
	JSR SUBL_SET_MAP16
	SEP #$30
	RTS

SUBL_SET_MAP16: 
                    PHX
                    TAX
                    JSR SUB_8034
                    PLX
                    RTS

RETURN18            PLX
                    PLB
                    RTS

SUB_8034            SEP #$20
                    PHB
                    LDA #$00
                    PHA
                    PLB
                    REP #$30
                    PHX
                    LDA $9A
                    STA $0C
                    LDA $98
                    STA $0E
                    LDA.W #$0000
                    SEP #$20
                    LDA $5B
                    STA $09
                    LDA $1933
                    BEQ NO_SHIFT
                    LSR $09
NO_SHIFT            LDY $0E
                    LDA $09
                    AND #$01
                    BEQ HORIZ
                    LDA $9B
                    STA $00
                    LDA $99
                    STA $9B
                    LDA $00
                    STA $99
                    LDY $0C
HORIZ               CPY.W #$0200
                    BCS RETURN18
                    LDA $1933
                    ASL A
                    TAX
                    LDA $BEA8,x
                    STA $65
                    LDA $BEA9,x
                    STA $66
                    STZ $67
                    LDA $1925
                    ASL A
                    TAY
                    LDA ($65),y
                    STA $04
                    INY
                    LDA ($65),y
                    STA $05
                    STZ $06
                    LDA $9B
                    STA $07
                    ASL A
                    CLC
                    ADC $07
                    TAY
                    LDA ($04),y 
                    STA $6B
                    STA $6E
                    INY
                    LDA ($04),y
                    STA $6C
                    STA $6F
                    LDA #$7E
                    STA $6D
                    INC A
                    STA $70
                    LDA $09
                    AND #$01
                    BEQ NO_AND
                    LDA $99
                    LSR A
                    LDA $9B 
                    AND #$01
                    BRA LABEL52
NO_AND              LDA $9B
                    LSR A
                    LDA $99
LABEL52             ROL A
                    ASL A
                    ASL A
                    ORA #$20
                    STA $04
                    CPX.W #$0000
                    BEQ NO_ADD
                    CLC
                    ADC #$10 
                    STA $04
NO_ADD              LDA $98
                    AND #$F0
                    CLC
                    ASL A
                    ROL A
                    STA $05
                    ROL A
                    AND #$03
                    ORA $04
                    STA $06
                    LDA $9A
                    AND #$F0
                    LSR A
                    LSR A
                    LSR A
                    STA $04
                    LDA $05
                    AND #$C0
                    ORA $04
                    STA $07
                    REP #$20
                    LDA $09
                    AND.W #$0001
                    BNE LABEL51
                    LDA $1A
                    SEC
                    SBC.W #$0080
                    TAX
                    LDY $1C
                    LDA $1933
                    BEQ LABEL50
                    LDX $1E
                    LDA $20
                    SEC
                    SBC.W #$0080
                    TAY
                    BRA LABEL50
LABEL51             LDX $1A
                    LDA $1C
                    SEC
                    SBC.W #$0080
                    TAY
                    LDA $1933
                    BEQ LABEL50
                    LDA $1E
                    SEC
                    SBC.W #$0080
                    TAX  
                    LDY $20
LABEL50             STX $08
                    STY $0A
                    LDA $98
                    AND.W #$01F0
                    STA $04
                    LDA $9A
                    LSR A
                    LSR A
                    LSR A
                    LSR A
                    AND.W #$000F
                    ORA $04
                    TAY
                    PLA
                    SEP #$20
                    STA [$6B],y
                    XBA
                    STA [$6E],y
                    XBA
                    REP #$20
                    ASL A
                    TAY
                    PHK
                    PER.W #$0006
                    PEA $804C
                    JML $00C0FB
MAP16_RETURN        PLB
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B829 - vertical mario/sprite position check - shared
; Y = 1 if mario below sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B829

SUB_VERT_POS        LDY #$00               ;A:25A1 X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizCHC:0130 VC:085 00 FL:924
                    LDA $96                ;A:25A1 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdiZCHC:0146 VC:085 00 FL:924
                    SEC                    ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0170 VC:085 00 FL:924
                    SBC $D8,x              ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0184 VC:085 00 FL:924
                    STA $0F                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0214 VC:085 00 FL:924
                    LDA $97                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0238 VC:085 00 FL:924
                    SBC $14D4,x            ;A:2501 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizcHC:0262 VC:085 00 FL:924
                    BPL LABEL11            ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0294 VC:085 00 FL:924
                    INY                    ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0310 VC:085 00 FL:924
LABEL11             RTS                    ;A:25FF X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizcHC:0324 VC:085 00 FL:924


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817

SUB_HORZ_POS        LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; off screen processing code - shared
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B83B             

TABLE3              dcb $40,$B0
TABLE6              dcb $01,$FF 
TABLE4              dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0 
TABLE5              dcb $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X0   LDA #$06                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ; | 
SUB_OFF_SCREEN_X1   LDA #$04                ; |
                    BRA STORE_03            ; |
SUB_OFF_SCREEN_X2   LDA #$02                ; |
STORE_03            STA $03                 ; |
                    BRA START_SUB           ; |
SUB_OFF_SCREEN_X3  STZ $03                 ; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_2            ; /    
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ 
                    AND #$01                ; | 
                    ORA $03                 ; | 
                    STA $01                 ; |
                    TAY                     ; /
                    LDA $1A
                    CLC
                    ADC TABLE4,y
                    ROL $00
                    CMP $E4,x
                    PHP
                    LDA $1B
                    LSR $00
                    ADC TABLE5,y
                    PLP
                    SBC $14E0,x
                    STA $00
                    LSR $01
                    BCC LABEL20
                    EOR #$80
                    STA $00
LABEL20             LDA $00
                    BPL RETURN_2
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /
                    LDY $161A,x
                    CPY #$FF
                    BEQ KILL_SPRITE
                    LDA #$00
                    STA $1938,y
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_2            RTS                     ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ only handle every other frame??
                    LSR A                   ; | 
                    BCS RETURN_2            ; /
                    AND #$01
                    STA $01
                    TAY
                    LDA $1C
                    CLC
                    ADC TABLE3,y
                    ROL $00
                    CMP $D8,x
                    PHP
                    LDA.W $001D
                    LSR $00
                    ADC TABLE6,y
                    PLP
                    SBC $14D4,x
                    STA $00
                    LDY $01
                    BEQ LABEL22
                    EOR #$80
                    STA $00
LABEL22             LDA $00
                    BPL RETURN_2
                    BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / return