;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Kbc}̊ (ネbN}) by tan-cos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_NAM	= $01		;<------̃XvCgԍ

Y_SP		= $AA
X_SP		= $B6
Y_LOW		= $D8
X_LOW		= $E4
HP_MARIO	= $0F48
Y_HIGH		= $14D4
X_HIGH		= $14E0
POSE		= $1504
TOUCH		= $1588		;HFLR
STATE		= $151C
TIMER		= $1564
SP_RAM		= $1594
FLAG		= $164A
SET_YL		= $178B
SET_YH		= $1793
SET_XL		= $179B
SET_XH		= $17A3
SET_SP  	= $187B

X_RIGHT		dcb $40,$40,$30,$30
X_LEFT		dcb $C0,$C0,$D0,$D0
Y_SPEED		dcb $D0,$00,$E0,$00
SIZE_MAP	dcb $16,$00

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	dcb "INIT"
	RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	dcb "MAIN"
	PHB                     ; \
	PHK                     ;  | main sprite function, just calls local subroutine
	PLB                     ;  |
	JSR START_HB_CODE       ;  |
	PLB                     ;  |
	RTL                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN:
	RTS
START_HB_CODE:
	JSR SUB_GFX
	LDA $14C8,x
	CMP #$08
	BNE RETURN
	LDA $9D
	BNE RETURN
	JSR SUB_OFF_SCREEN_X0
	
	PHY
	LDA POSE,x
	TAY
	LDA SIZE_MAP,y
	STA $1662,x
	PLY
	
	LDA STATE,x
	BNE SKIP
	JSR SUB_HORZ_POS
	TYA
	STA $157C,x
	LDA #$01
	STA STATE,x
SKIP
	LDA POSE,x
	BEQ BIG
	JMP SMALL_LAST
BIG:
	LDA $1588,x
	BNE CRASH
	JMP BIG_LAST
CRASH:
	LDA #$07
	STA $1DFC			;SE:CRASH
	LDA X_LOW,x
	SEC
	SBC #$08
	STA SET_XL,x
	LDA X_HIGH,x
	SBC #$00
	STA SET_XH,x
	
	LDA Y_LOW,x
	SEC
	SBC #$10
	STA SET_YL,x
	LDA Y_HIGH,x
	SBC #$00
	STA SET_YH,x
	LDA #SPRITE_NAM
	STA SET_SP,x
	JSR GEN_CUSTOM
	LDA #$00
	STA FLAG,y
	LDA #$01
	STA POSE,y
	LDA 157C,x
	STA 157C,y
	
	LDA X_LOW,x
	CLC
	ADC #$08
	STA SET_XL,x
	LDA X_HIGH,x
	ADC #$00
	STA SET_XH,x
	
	LDA Y_LOW,x
	SEC
	SBC #$10
	STA SET_YL,x
	LDA Y_HIGH,x
	SBC #$00
	STA SET_YH,x
	LDA #SPRITE_NAM
	STA SET_SP,x
	JSR GEN_CUSTOM
	LDA #$01
	STA FLAG,y
	LDA #$01
	STA POSE,y
	LDA 157C,x
	STA 157C,y
	
	LDA X_LOW,x
	SEC
	SBC #$08
	STA SET_XL,x
	LDA X_HIGH,x
	SBC #$00
	STA SET_XH,x
	
	LDA Y_LOW,x
	STA SET_YL,x
	LDA Y_HIGH,x
	STA SET_YH,x
	LDA #SPRITE_NAM
	STA SET_SP,x
	JSR GEN_CUSTOM
	LDA #$02
	STA FLAG,y
	LDA #$01
	STA POSE,y
	LDA 157C,x
	STA 157C,y
	
	LDA X_LOW,x
	CLC
	ADC #$08
	STA SET_XL,x
	LDA X_HIGH,x
	ADC #$00
	STA SET_XH,x
	
	LDA Y_LOW,x
	STA SET_YL,x
	LDA Y_HIGH,x
	STA SET_YH,x
	LDA #SPRITE_NAM
	STA SET_SP,x
	JSR GEN_CUSTOM
	LDA #$03
	STA FLAG,y
	LDA #$01
	STA POSE,y
	LDA 157C,x
	STA 157C,y

	LDA #$00
	STA $14C8,x
	RTS
BIG_LAST:
	JSL $01802A
	JMP TURN
SMALL_LAST:
	LDA $157C,x
	BEQ LABEL_DIR
	PHY
	LDA FLAG,x
	TAY
	LDA X_LEFT,y
	STA X_SP,x
	LDA Y_SPEED,y
	STA Y_SP,x
	PLY
	BRA LABEL_SMALL
LABEL_DIR:
	PHY
	LDA FLAG,x
	TAY
	LDA X_RIGHT,y
	STA X_SP,x
	LDA Y_SPEED,y
	STA Y_SP,x
	PLY
LABEL_SMALL:
	JSL $018022
	JSL $01801A
	JMP TURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  damage routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TURN:
	JSL $01A7DC			;蔻
	BCC NOT_CONTACT
	LDA $1497
	BNE NOT_CONTACT
	LDA HP_MARIO
	CMP #$04
	BCC TKTK
	BEQ TKTK
	LDA #$04
	STA $1DF9
	LDA HP_MARIO
	SEC
	SBC #$04
	STA HP_MARIO
	LDA #$40
	STA $1497
	RTS
TKTK
	LDA #$00
	STA HP_MARIO
	RTS
NOT_CONTACT:
	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TILENAM             dcb $03,$00

TILEMAP             dcb $4C,$4E,$6C,$6E						;PTT
                    dcb $48,$4A

X_OFFSET            dcb $08,$F8,$08,$F8,$F8,$08,$F8,$08		;PDTT
                    dcb $00,$00,$00,$00,$00,$00,$00,$00

Y_OFFSET            dcb $F0,$F0,$00,$00						;PTT
                    dcb $00,$00

SUB_GFX             JSR GET_DRAW_INFO
                    LDA $157C,x
                    ASL A
                    ASL A
                    STA $02			;$02 = 
                    LDA POSE,x
                    STA $05			;$05 = |[Y(TILENAMp)
                    ASL A
                    ASL A
                    STA $03			;$03 = |[Y
                    ASL A
                    STA $06			;$06 = |[Y(X_OFFSETp)
                    LDA #$00
                    STA $04
                    LDA $05
                    BEQ NO_ANIME
                    LDA $14
                    AND #$08
                    LSR A
                    LSR A
                    LSR A
                    STA $04			;$04 = t[JE^
NO_ANIME
                    PHX
                    
                    PHY
                    LDA $05
                    TAY
                    LDA TILENAM,y
                    STA $07
                    TAX
                    PLY

LOOP_START          PHX
                    TXA
                    ORA $02
                    ORA $06
                    TAX
                    LDA X_OFFSET,x
                    CLC
                    ADC $00                 ; \ tile x position = sprite y location ($01)
                    STA $0300,y             ; /
                    PLX

                    PHX
                    TXA
                    ORA $03
                    TAX
                    LDA Y_OFFSET,x
                    CLC
                    ADC $01                 ; \ tile y position = sprite x location ($00)
                    STA $0301,y             ; /
                    PLX

                    PHX
                    TXA
                    ORA $03
                    ORA $04
                    TAX
                    LDA TILEMAP,x
                    STA $0302,y 
                    PLX
                    
                    PHX
                    LDX $15E9
                    LDA $15F6,x             ; tile properties xyppccct, format
                    LDX $02                 ; \ if direction == 0...
                    BNE NO_FLIP             ;  |
                    ORA #$40                ; /    ...flip tile
NO_FLIP             ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
                    PLX
                    INY                     ; \ increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ; /    ...so increment 4 times
                    DEX
                    BPL LOOP_START

                    PLX
                    LDY #$02                ; \ 460 = 2 (all 16x16 tiles)
                    LDA $07
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; generate sprite
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GEN_CUSTOM
	JSL $02A9DE
	BMI RETURN68
	LDA #$08
	STA $14C8,y
	LDA SET_SP,x
	PHX
	TYX
	STA $7FAB9E,x
	PLX
	LDA SET_XL,x
	STA $00E4,y
	LDA #$00
	STA $14E0,y
	LDA SET_YL,x
	STA $00D8,y
	LDA SET_YH,x
	STA $14D4,y
	LDA $157C,x
	STA $157C,y
	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7
	LDA #$88
	STA $7FAB10,x
	PLX
RETURN68
	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817

SUB_HORZ_POS        LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; off screen processing code - shared
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B83B             

TABLE3              dcb $40,$B0
TABLE6              dcb $01,$FF 
TABLE4              dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0 
TABLE5              dcb $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X0   LDA #$06                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ; | 
SUB_OFF_SCREEN_X1   LDA #$04                ; |
                    BRA STORE_03            ; |
SUB_OFF_SCREEN_X2   LDA #$02                ; |
STORE_03            STA $03                 ; |
                    BRA START_SUB           ; |
SUB_OFF_SCREEN_X3  STZ $03                 ; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_2            ; /    
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ 
                    AND #$01                ; | 
                    ORA $03                 ; | 
                    STA $01                 ; |
                    TAY                     ; /
                    LDA $1A
                    CLC
                    ADC TABLE4,y
                    ROL $00
                    CMP $E4,x
                    PHP
                    LDA $1B
                    LSR $00
                    ADC TABLE5,y
                    PLP
                    SBC $14E0,x
                    STA $00
                    LSR $01
                    BCC LABEL20
                    EOR #$80
                    STA $00
LABEL20             LDA $00
                    BPL RETURN_2
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /
                    LDY $161A,x
                    CPY #$FF
                    BEQ KILL_SPRITE
                    LDA #$00
                    STA $1938,y
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_2            RTS                     ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ only handle every other frame??
                    LSR A                   ; | 
                    BCS RETURN_2            ; /
                    AND #$01
                    STA $01
                    TAY
                    LDA $1C
                    CLC
                    ADC TABLE3,y
                    ROL $00
                    CMP $D8,x
                    PHP
                    LDA.W $001D
                    LSR $00
                    ADC TABLE6,y
                    PLP
                    SBC $14D4,x
                    STA $00
                    LDY $01
                    BEQ LABEL22
                    EOR #$80
                    STA $00
LABEL22             LDA $00
                    BPL RETURN_2
                    BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / return